/*
	$Id: Methods.java 305 2007-03-16 18:35:59Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
   ֥ȥ饯ȥ᥽åɤޤϴؿΥåȤǤ
*/
public abstract class Methods {

    /** ᥽åɤΥꥹ */
    protected LinkedList<Method> v;

    /**
       ᥽åɤΥåȤޤ

       @param g 롼
       @param nodes ᥽åɤΥΡɥꥹ
    */
    protected Methods(final Group g, final NodeList nodes) {
	v = new LinkedList<Method>();

	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    Method m = createMethod(g, elem);
	    v.add(m);
	}
    }

    /**
       ᥽åɤޤ

       @param g 롼
       @param elem methodǤޤabstract
       @return ᥽å
    */
    protected abstract Method createMethod(final Group g, final Element elem);

    /**
       ΥإåHTMLǽϤޤ

       @param wr 饤
    */
    protected abstract void printSummaryHeader(final PrintWriter wr);

    /**
       ܺ٤ΥإåHTMLǽϤޤ

       @param wr 饤
    */
    protected abstract void printDetailHeader(final PrintWriter wr);

    /**
       ܺ٤ΥإåTeXǽϤޤ

       @param wr 饤
    */
    protected abstract void printTexDetailHeader(final PrintWriter wr);

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public final void printSummary(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printSummaryHeader(wr);
	wr.println(""
+ "    <table width=\"100%\" cellspacing=\"0\" border=\"1\">");
	for (Method m : v) {
	    m.printSummary(wr);
	}
	wr.println(""
+ "    </table>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public final void printDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printDetailHeader(wr);
	for (Method m : v) {
	    m.printDetail(wr);
	    wr.println("<hr>");
	}
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public final void printTexDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printTexDetailHeader(wr);
	for (Method m : v) {
	    m.printTexDetail(wr);
	}
    }
}
