/*
	$Id: Strings.java 307 2007-03-22 21:08:11Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

/**
   û̷ʸǤ
*/
public final class Strings {

    /** ʸδ */
    private String full;

    /** ʸû̷ */
    private String shorten;

    /**
       ʸޤ

       @param full ʸ
       @param shorten û̷ʸ
    */
    private Strings(final String full, final String shorten) {
	this.full = full;
	this.shorten = shorten;
    }

    /**
       û̷ʸޤ

       @param full ʸ
    */
    private Strings(final String full) {
	this.full = full;
	this.shorten = full;
    }

    /**
       ʸޤ

       @param full ʸ
       @param shorten û̷ʸ
       @return ʸ
    */
    public static Strings intern(final String full, final String shorten) {
	return new Strings(full, shorten);
    }

    /**
       û̷ʸޤ

       @param s ʸ
       @return ʸ
    */
    public static Strings intern(final String s) {
	return new Strings(s);
    }

    /**
       Ƭꤷʸޤ

       @param prefix Ƭ
       @param s ʸ
       @return ʸ
    */
    public static Strings prepend(final String prefix, final Strings s) {
	return new Strings(prefix + s.full, prefix + s.shorten);
    }

    /**
       ʸδޤ

       @return ʸ
    */
    public String getFull() {
	return full;
    }

    /**
       ʸû̷ޤ

       @return û̷ʸ
    */
    public String getShorten() {
	return shorten;
    }

    /**
       {@inheritDoc}
    */
    @Override public String toString() {
	return full;
    }
}
